
public class Jugador {

	public Ficha[] fichas; //No tenemos aun la clase Ficha
    public int[] colocada;  //Es donde una pieza deberia ser colocada "de verdad"
    						// Es su opuesta (por ejemplo la 0 debe colocarse en la 255)
    public boolean[] boolColocada;
    public int movimientos; //Numero de movimientos realizados (si se hacen 2 saltos en el
    						// mismo turno, pues serian 2 movimientos)
    public int numHeuristica;
    public int nivelProfundidad;
    public boolean esPC;  //si esPC es true, el jugador es la maquina, si es false, el jugador mueve manualmente
    public int combomax; //Numero de saltos realizados
    public int colocadas; //Numero de piezas colocadas
    public int distanciaTotal; //Distancia de todas las fichas al punto central
    public int puntoCentral; // Marca la posicion que hace de punto central para un jugador
    public int ultimaFicha; // Ultima ficha que se movio
    public int ultimaCasilla; // Ultima casilla que se visito (supongo que es la casillaSeleccionada y no la 
    						  // casillaCandidata)
    
    public Jugador(int num) //Constructor inicial (le pasamos el numero del jugador)
    {
        ultimaFicha = -1; //No ha sido ninguna
        ultimaCasilla = -1; //No ha sido ninguna

        numHeuristica = -1;
        nivelProfundidad = -1;
        esPC = false;  //De momento vamsoa suponer siemrpe que es manual
        movimientos = 0;
        combomax = 0;
        colocadas = 0;
        distanciaTotal = 272; //Suma de las distancias de las fichas a la ultima 
        						//(la esquina opuesta)
        
        //distanciaTotal = 255; //Si usamos la heuristica de colocada en su correspondiente casilla
        						//Por defecto le ponemos la otra, que es mayor
    
        colocada = new int[19];
        boolColocada = new boolean[19];
        fichas = new Ficha[19];
        
        switch(num)
        {
            case 1:
                puntoCentral = 255; //Posicion de la esquina opuesta                    
                
                fichas[0] = new Ficha(0);
                fichas[1] = new Ficha(1);
                fichas[2] = new Ficha(2);
                fichas[3] = new Ficha(3);
                fichas[4] = new Ficha(4);
                fichas[5] = new Ficha(16);
                fichas[6] = new Ficha(17);
                fichas[7] = new Ficha(18);
                fichas[8] = new Ficha(19);
                fichas[9] = new Ficha(20);
                fichas[10] = new Ficha(32);
                fichas[11] = new Ficha(33);
                fichas[12] = new Ficha(34);
                fichas[13] = new Ficha(35);
                fichas[14] = new Ficha(48);
                fichas[15] = new Ficha(49);
                fichas[16] = new Ficha(50);
                fichas[17] = new Ficha(64);
                fichas[18] = new Ficha(65);
                
                
                colocada[0] = 255;
                colocada[1] = 239;
                colocada[2] = 223;
                colocada[3] = 207;
                colocada[4] = 191;
                colocada[5] = 254;
                colocada[6] = 238;
                colocada[7] = 222;
                colocada[8] = 206;
                colocada[9] = 190;
                colocada[10] = 253;
                colocada[11] = 237;
                colocada[12] = 221;
                colocada[13] = 205;
                colocada[14] = 252;
                colocada[15] = 236;
                colocada[16] = 220;
                colocada[17] = 251;
                colocada[18] = 235;
                break;
                
            case 2:
                puntoCentral = 0; //Posicion de la esquina opuesta                    
                
                fichas[0] = new Ficha(190);
                fichas[1] = new Ficha(191);
                fichas[2] = new Ficha(205);
                fichas[3] = new Ficha(206);
                fichas[4] = new Ficha(207);
                fichas[5] = new Ficha(220);
                fichas[6] = new Ficha(221);
                fichas[7] = new Ficha(222);
                fichas[8] = new Ficha(223);
                fichas[9] = new Ficha(235);
                fichas[10] = new Ficha(236);
                fichas[11] = new Ficha(237);
                fichas[12] = new Ficha(238);
                fichas[13] = new Ficha(239);
                fichas[14] = new Ficha(251);
                fichas[15] = new Ficha(252);
                fichas[16] = new Ficha(253);
                fichas[17] = new Ficha(254);
                fichas[18] = new Ficha(255);
                
                colocada[0] = 20; //Hace referencia a la ficha 19 (la primera del jugador 2)
                colocada[1] = 4; //Hace referencia a la ficha 20 (la segunda del jugador 2)
                colocada[2] = 35;
                colocada[3] = 19;
                colocada[4] = 3;
                colocada[5] = 50;
                colocada[6] = 34;
                colocada[7] = 18;
                colocada[8] = 2;
                colocada[9] = 65;
                colocada[10] = 49;
                colocada[11] = 33;
                colocada[12] = 17;
                colocada[13] = 1;
                colocada[14] = 64;
                colocada[15] = 48;
                colocada[16] = 32;
                colocada[17] = 16;
                colocada[18] = 0;
                break;
                
            case 3:
                puntoCentral = 240; //Posicion de la esquina opuesta                    
                
                fichas[0] = new Ficha(11);
                fichas[1] = new Ficha(12);
                fichas[2] = new Ficha(13);
                fichas[3] = new Ficha(14);
                fichas[4] = new Ficha(15);
                fichas[5] = new Ficha(27);
                fichas[6] = new Ficha(28);
                fichas[7] = new Ficha(29);
                fichas[8] = new Ficha(30);
                fichas[9] = new Ficha(31);
                fichas[10] = new Ficha(44);
                fichas[11] = new Ficha(45);
                fichas[12] = new Ficha(46);
                fichas[13] = new Ficha(47);
                fichas[14] = new Ficha(61);
                fichas[15] = new Ficha(62);
                fichas[16] = new Ficha(63);
                fichas[17] = new Ficha(78);
                fichas[18] = new Ficha(79);
                
                colocada[0] = 176; //Hace referencia a la ficha 38 (la primera del jugador 3)
                colocada[1] = 192; //Hace referencia a la ficha 39 (la segunda del jugador 3)
                colocada[2] = 208;
                colocada[3] = 224;
                colocada[4] = 240;
                colocada[5] = 177;
                colocada[6] = 193;
                colocada[7] = 209;
                colocada[8] = 225;
                colocada[9] = 241;
                colocada[10] = 194;
                colocada[11] = 210;
                colocada[12] = 226;
                colocada[13] = 242;
                colocada[14] = 211;
                colocada[15] = 227;
                colocada[16] = 243;
                colocada[17] = 228;
                colocada[18] = 244;
                break;
                
            case 4:
                puntoCentral = 15; //Posicion de la esquina opuesta                    
                
                fichas[0] = new Ficha(176);
                fichas[1] = new Ficha(177);
                fichas[2] = new Ficha(192);
                fichas[3] = new Ficha(193);
                fichas[4] = new Ficha(194);
                fichas[5] = new Ficha(208);
                fichas[6] = new Ficha(209);
                fichas[7] = new Ficha(210);
                fichas[8] = new Ficha(211);
                fichas[9] = new Ficha(224);
                fichas[10] = new Ficha(225);
                fichas[11] = new Ficha(226);
                fichas[12] = new Ficha(227);
                fichas[13] = new Ficha(228);
                fichas[14] = new Ficha(240);
                fichas[15] = new Ficha(241);
                fichas[16] = new Ficha(242);
                fichas[17] = new Ficha(243);
                fichas[18] = new Ficha(244);
                
                colocada[0] = 11; //Hace referencia a la ficha 57 (la primera del jugador 4)
                colocada[1] = 27; //Hace referencia a la ficha 58 (la segunda del jugador 4)
                colocada[2] = 12;
                colocada[3] = 28;
                colocada[4] = 44;
                colocada[5] = 13;
                colocada[6] = 29;
                colocada[7] = 45;
                colocada[8] = 61;
                colocada[9] = 14;
                colocada[10] = 30;
                colocada[11] = 46;
                colocada[12] = 62;
                colocada[13] = 78;
                colocada[14] = 15;
                colocada[15] = 31;
                colocada[16] = 47;
                colocada[17] = 63;
                colocada[18] = 79;
                break;

            default:                    
                //error;
                break;
        }

    }
    
    public void setHeuristica(int numHeuristica)
    {
    	this.numHeuristica = numHeuristica;
    }
    public void setProfundidad(int nivelProfundidad)
    {
    	this.nivelProfundidad = nivelProfundidad;
    }
    
    public void calcularDistanciaTotalFichasColocadas()
    {
        boolean[] fichaColocada = new boolean[19];
        boolean[] casillaColocada = new boolean[19];
        int aux;
        
        distanciaTotal = 0;
        for (int i = 0; i < 19; i++)
        {
            fichaColocada[i] = false;
            for (int j = 0; j < 19; j++)
            {
                if (fichas[i].numcasilla == colocada[j]) 
                {
                    fichaColocada[i] = true;
                    casillaColocada[j] = true;
                }
            }
        }

        aux = 0;
        for (int i = 0; i < 19; i++)
        {
            if (!fichaColocada[i])
            {
                for (int j = 0; j < 19; j++)
                {
                    if (!casillaColocada[j])
                        aux += Estaticos.distancia[fichas[i].numcasilla][colocada[j]];
                }
                aux /= (19 - colocadas);
                distanciaTotal += aux;
            }
        }
    }
    
    public void calcularDistanciaTotalPuntoCentral() //Usamos la distancia desde la casilla de la ficha 
    												//al punto central, es similar a la anterior
    {
        boolean[] fichaColocada = new boolean[19];
        boolean[] casillaColocada = new boolean[19];
        int aux;
        
        distanciaTotal = 0;
        for (int i = 0; i < 19; i++)
        {
            fichaColocada[i] = false;
            for (int j = 0; j < 19; j++)
            {
                if (fichas[i].numcasilla == colocada[j]) 
                {
                    fichaColocada[i] = true;
                    casillaColocada[j] = true;
                }
            }
        }

        aux = 0;
        for (int i = 0; i < 19; i++)
        {
            if (!fichaColocada[i])
            {
                for (int j = 0; j < 19; j++)
                {
                    if (!casillaColocada[j])
                        aux += Estaticos.distancia[fichas[i].numcasilla][puntoCentral];
                }
                aux /= (19 - colocadas);
                distanciaTotal += aux;
            }
        }
    }
    
    //Aqui falta el update
}
